#pragma once

#define VC_EXTRALEAN
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
//#include <afxwin.h>

/*
#ifndef APIENTRY
#define APIENTRY
#endif
#ifndef HGLRC
//typedef void* HGLRC;
#define HGLRC void*
#endif
#ifndef HDC
//typedef void* HDC;
#define HDC void*
#endif
#  ifndef WINGDIAPI
#   define WINGDIAPI __declspec(dllimport)
#  endif
*/
#include <GL/gl.h>
#include "glext.h"
#include "core/Defs.h"
#include "RenderAPI.h"

HGLRC gfxCreateGLContext(HDC hdc, bool need_window);
void gfxSetContext(HGLRC hglrc, HDC dc);
bool gfxInitExtensions();
void gfxDeleteContext();
void gfxFlip();

void gfxCgInit();
void gfxCgShutdown();
const char* gfxCgCompileShader(const char* source, const char* profile);

void gfxEnableRenderTarget(RenderTarget* rt);
void gfxDisableRenderTarget(RenderTarget* rt);
void gfxBindRenderTarget(uint texUnit, RenderTarget* rt);
void gfxUnbindRenderTarget(uint texUnit, RenderTarget* rt);

// TODO: Use glDrawRangeElementsEXT if ARB not avail..
extern PFNGLDRAWRANGEELEMENTSPROC	glDrawRangeElementsARB;
extern PFNGLVERTEXATTRIB4FPROC glVertexAttrib4f;
extern PFNGLVERTEXATTRIBPOINTERPROC glVertexAttribPointer;
extern PFNGLENABLEVERTEXATTRIBARRAYPROC glEnableVertexAttribArray;
extern PFNGLDISABLEVERTEXATTRIBARRAYPROC glDisableVertexAttribArray;

// multi texturing
extern PFNGLCLIENTACTIVETEXTUREPROC glClientActiveTextureARB;
extern PFNGLACTIVETEXTUREARBPROC    glActiveTextureARB;
extern PFNGLMULTITEXCOORD2FPROC     glMultiTexCoord2fARB;
extern PFNGLMULTITEXCOORD3FPROC     glMultiTexCoord3fARB;

// vertex buffer objects
extern PFNGLGENBUFFERSARBPROC    glGenBuffersARB ;
extern PFNGLBINDBUFFERARBPROC    glBindBufferARB ;
extern PFNGLBUFFERDATAARBPROC    glBufferDataARB ;
extern PFNGLDELETEBUFFERSARBPROC glDeleteBuffersARB ;
extern PFNGLMAPBUFFERPROC        glMapBufferARB ;
extern PFNGLUNMAPBUFFERPROC      glUnmapBufferARB;

// ARB_vertex_program + ARB_fragment_program
extern PFNGLGENPROGRAMSARBPROC					glGenProgramsARB;
extern PFNGLPROGRAMSTRINGARBPROC				glProgramStringARB;
extern PFNGLBINDPROGRAMARBPROC					glBindProgramARB;
extern PFNGLDELETEPROGRAMSARBPROC				glDeleteProgramsARB;
extern PFNGLPROGRAMENVPARAMETER4FARBPROC		glProgramEnvParameter4fARB;
extern PFNGLPROGRAMENVPARAMETER4FVARBPROC		glProgramEnvParameter4fvARB;
extern PFNGLPROGRAMLOCALPARAMETER4FARBPROC		glProgramLocalParameter4fARB;
extern PFNGLPROGRAMLOCALPARAMETER4FVARBPROC		glProgramLocalParameter4fvARB;

// GLSL shader stuff
extern PFNGLCREATESHADEROBJECTARBPROC   glCreateShaderObjectARB ;
extern PFNGLSHADERSOURCEARBPROC         glShaderSourceARB ;
extern PFNGLCOMPILESHADERARBPROC        glCompileShaderARB ;
extern PFNGLCREATEPROGRAMOBJECTARBPROC  glCreateProgramObjectARB ;
extern PFNGLATTACHOBJECTARBPROC         glAttachObjectARB ;
extern PFNGLLINKPROGRAMARBPROC          glLinkProgramARB ;
extern PFNGLUSEPROGRAMOBJECTARBPROC     glUseProgramObjectARB ;
extern PFNGLGETOBJECTPARAMETERFVARBPROC glGetObjectParameterfvARB ;
extern PFNGLGETOBJECTPARAMETERIVARBPROC glGetObjectParameterivARB ;
extern PFNGLGETINFOLOGARBPROC           glGetInfoLogARB;
extern PFNGLGETUNIFORMLOCATIONARBPROC   glGetUniformLocationARB;
extern PFNGLUNIFORM1FARBPROC            glUniform1fARB;
extern PFNGLUNIFORM2FARBPROC            glUniform2fARB;
extern PFNGLUNIFORM3FARBPROC            glUniform3fARB;
extern PFNGLUNIFORM4FARBPROC            glUniform4fARB;
extern PFNGLUNIFORM1FVARBPROC           glUniform1fvARB;
extern PFNGLUNIFORM2FVARBPROC           glUniform2fvARB;
extern PFNGLUNIFORM3FVARBPROC           glUniform3fvARB;
extern PFNGLUNIFORM4FVARBPROC           glUniform4fvARB;

// two-sided stencil
/*
extern PFNGLACTIVESTENCILFACEEXTPROC    glActiveStencilFaceEXT;   // nvidia
extern PFNGLSTENCILOPSEPARATEATIPROC    glStencilOpSeparateATI;   // ati
extern PFNGLSTENCILFUNCSEPARATEATIPROC  glStencilFuncSeparateATI; // ati
*/

// fbo
extern PFNGLGENFRAMEBUFFERSEXTPROC      glGenFramebuffersEXT;
extern PFNGLBINDFRAMEBUFFEREXTPROC      glBindFramebufferEXT;
extern PFNGLGENRENDERBUFFERSEXTPROC     glGenRenderbuffersEXT;
extern PFNGLRENDERBUFFERSTORAGEEXTPROC  glRenderbufferStorageEXT;
extern PFNGLFRAMEBUFFERRENDERBUFFEREXTPROC glFramebufferRenderbufferEXT;
extern PFNGLFRAMEBUFFERTEXTURE2DEXTPROC glFramebufferTexture2DEXT;
extern PFNGLCHECKFRAMEBUFFERSTATUSEXTPROC glCheckFramebufferStatusEXT;
extern PFNGLBINDRENDERBUFFEREXTPROC     glBindRenderbufferEXT;
