#pragma once
#include "core/Defs.h"

class TextureManager
{
public:
	enum { MAX_TEXTURES = 128 };

	TextureManager() : m_tex_count(0) {}
	u32 GetTexture(const char* filename, bool mipMaps = true);
	void FreeTextures();
private:
	struct TextureDesc {
		u32 handle;
		int refCount;
		char filename[64];
		bool mipMaps;
		//bool isLoaded;
	};

	TextureDesc m_textures[MAX_TEXTURES];
	size_t m_tex_count;

	TextureDesc* FindTexture(const char* filename);
};
